function [t,I]=affine_mask(x,scale,I1,I2,type,lb,ub)
    x = x.*(ub-lb) + lb;
    [t,I]=affine_registration_image(x,scale,I1,I2,type);
    % - THE FUNCTION WHOSE SUM OF SQUARES IS MINIMIZED:
    % @(x)affine_registration_image(x,scale,I1s,I2s,type)
    % x --> Rigid vector of length 3 -> [translateX translateY rotate] or
    %       Affine vector of length 7 -> [translateX translateY rotate resizeX
    %       resizeY shearXY shearYX]
    % scale --> Vector with Scaling of the input parameters with the same lenght
    %          as the parameter vector.
    % I1 --> The 2D/3D image which is affine transformed
    % I2 --> The second 2D/3D image which is used to calculate the
    %        registration error
    % type --> The type of registration error used see image_difference.m
    %           if type,
    %           'd'  : differences between I1 and I2
    %           'sd' : squared differences
    %           'mi' : normalized mutual information
    %           'mip': normalized mutual information with image split in multiple small regions
    %           'gd' : gradient differences
    %           'gc' : gradient correlation
    %           'cc' : normalized cros correlation
    %           'pi' : pattern intensity
    %           'ld' : log absolute difference
    % - INITIAL POINT FOR X, SIMILAR SIZE AS SCALE
    % - VECTOR OF LOWER BOUNDS
    % - VECTOR OF HIGHER BOUNDS
    % - OPTIMIZATION OPTIONS
    % THE FUNCTION affine_registration_image RETURNS A VOLUME IMAGE WITH THE
    % REGISTRATION ERROR BETWEEN I1 AND I2. IT USES AFFINE TRANSFOMATION OF THE
    % 3D INPUT VOLUME AND CALCULATES THE REGISTRATION ERROR AFTER
    % TRANSFORMATION.
end