
function [globalResults] ...
    = calculatingGlobalStatistics(NUMBER_OF_IMAGES, totalTimeIterOtsuTemporal, TP_IterOtsuTemporal, FP_IterOtsuTemporal, ...
    FN_IterOtsuTemporal, totalTimeIterOtsuTemporalRefined, TP_IterOtsuTemporalRefined, FP_IterOtsuTemporalRefined, FN_IterOtsuTemporalRefined, evaluatedRegionsTemporal, ...
    totalTimeLevelSetsTemporal, TP_LevelSetsTemporal, FP_LevelSetsTemporal, FN_LevelSetsTemporal, DiceCoefficientLevelSetsTemporal, ...
    DiceCoefficientIterOtsuTemporal, DiceCoefficientIterOtsuTemporalRefined, HausdorffLevelSetsTemporal, HausdorffIterOtsuTemporal, HausdorffIterOtsuTemporalRefined)

%% IterOtsu METHOD
%% EXECUTION TIME
globalResults.AveragetotalTimeIterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AveragetotalTimeIterOtsu = [globalResults.AveragetotalTimeIterOtsu, mean([totalTimeIterOtsuTemporal{:,i}])];%mean(totalTimeIterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MediantotalTimeIterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MediantotalTimeIterOtsu = [globalResults.MediantotalTimeIterOtsu, median([totalTimeIterOtsuTemporal{:,i}])];%(totalTimeIterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdtotalTimeIterOtsu = std([totalTimeIterOtsuTemporal{:}]);

globalResults.AverageEvaluatedRegions = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageEvaluatedRegions = [globalResults.AverageEvaluatedRegions, mean([evaluatedRegionsTemporal{:,i}])];%mean(evaluatedRegionsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdEvaluatedRegions = std([evaluatedRegionsTemporal{:}]);%[StdEvaluatedRegions, std(evaluatedRegionsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


%% TRUE POSITIVES PERCENTAGE
globalResults.AverageTP_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageTP_IterOtsu = [globalResults.AverageTP_IterOtsu, mean([TP_IterOtsuTemporal{:,i}])];%mean(TP_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianTP_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianTP_IterOtsu = [globalResults.MedianTP_IterOtsu, median([TP_IterOtsuTemporal{:,i}])];%median(TP_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdTP_IterOtsu = std([TP_IterOtsuTemporal{:}]);%[StdTP_IterOtsu, std(TP_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


%% FALSE POSITIVES PERCENTAGE
globalResults.AverageFP_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageFP_IterOtsu = [globalResults.AverageFP_IterOtsu, mean([FP_IterOtsuTemporal{:,i}])];%mean(FP_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianFP_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianFP_IterOtsu = [globalResults.MedianFP_IterOtsu, median([FP_IterOtsuTemporal{:,i}])];%median(FP_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdFP_IterOtsu = std([FP_IterOtsuTemporal{:}]);%[StdFP_IterOtsu, std(FP_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


%% FALSE NEGATIVES PERCENTAGE
globalResults.AverageFN_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageFN_IterOtsu = [globalResults.AverageFN_IterOtsu, mean([FN_IterOtsuTemporal{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianFN_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianFN_IterOtsu = [globalResults.MedianFN_IterOtsu, median([FN_IterOtsuTemporal{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdFN_IterOtsu = std([FN_IterOtsuTemporal{:}]);%[StdFN_IterOtsu, std(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


%% DICE COEFFICIENT
globalResults.AverageDice_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageDice_IterOtsu = [globalResults.AverageDice_IterOtsu, mean([DiceCoefficientIterOtsuTemporal{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianDice_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianDice_IterOtsu = [globalResults.MedianDice_IterOtsu, median([DiceCoefficientIterOtsuTemporal{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdDice_IterOtsu = std([DiceCoefficientIterOtsuTemporal{:}]);

%% HAUSDORFF DISTANCE
globalResults.AverageHausdorff_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageHausdorff_IterOtsu = [globalResults.AverageHausdorff_IterOtsu, mean([HausdorffIterOtsuTemporal{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianHausdorff_IterOtsu = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianHausdorff_IterOtsu = [globalResults.MedianHausdorff_IterOtsu, median([HausdorffIterOtsuTemporal{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdHausdorff_IterOtsu = std([HausdorffIterOtsuTemporal{:}]);

%% LevelSets METHOD (in this case we only preprocess the small LevelSets created using as seed the located points)
%% EXECUTION TIME
globalResults.AveragetotalTimeLevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AveragetotalTimeLevelSets = [globalResults.AveragetotalTimeLevelSets, mean([totalTimeLevelSetsTemporal{:,i}])];%mean(totalTimeLevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MediantotalTimeLevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MediantotalTimeLevelSets = [globalResults.MediantotalTimeLevelSets, median([totalTimeLevelSetsTemporal{:,i}])];%median(totalTimeLevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdtotalTimeLevelSets = std([totalTimeLevelSetsTemporal{:}]);%[StdtotalTimeLevelSets, std(totalTimeLevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];

%% TRUE POSITIVES PERCENTAGE
globalResults.AverageTP_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageTP_LevelSets = [globalResults.AverageTP_LevelSets, mean([TP_LevelSetsTemporal{:,i}])];%mean(TP_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianTP_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianTP_LevelSets = [globalResults.MedianTP_LevelSets, median([TP_LevelSetsTemporal{:,i}])];%median(TP_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdTP_LevelSets = std([TP_LevelSetsTemporal{:}]);%[StdTP_LevelSets, std(TP_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


%% FALSE POSITIVES PERCENTAGE
globalResults.AverageFP_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageFP_LevelSets = [globalResults.AverageFP_LevelSets, mean([FP_LevelSetsTemporal{:,i}])];%mean(FP_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianFP_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianFP_LevelSets = [globalResults.MedianFP_LevelSets, median([FP_LevelSetsTemporal{:,i}])];%median(FP_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdFP_LevelSets = std([FP_LevelSetsTemporal{:}]);%[StdFP_LevelSets, std(FP_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


%% FALSE NEGATIVES PERCENTAGE
globalResults.AverageFN_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageFN_LevelSets = [globalResults.AverageFN_LevelSets, mean([FN_LevelSetsTemporal{:,i}])];%mean(FN_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianFN_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianFN_LevelSets = [globalResults.MedianFN_LevelSets,median([FN_LevelSetsTemporal{:,i}])];% median(FN_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdFN_LevelSets = std([FN_LevelSetsTemporal{:}]);%[StdFN_LevelSets, std(FN_LevelSetsTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];

%% DICE COEFFICIENT
globalResults.AverageDice_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageDice_LevelSets = [globalResults.AverageDice_LevelSets, mean([DiceCoefficientLevelSetsTemporal{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianDice_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianDice_LevelSets = [globalResults.MedianDice_LevelSets, median([DiceCoefficientLevelSetsTemporal{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdDice_LevelSets = std([DiceCoefficientLevelSetsTemporal{:}]);

%% HAUSDORFF DISTANCE
globalResults.AverageHausdorff_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageHausdorff_LevelSets = [globalResults.AverageHausdorff_LevelSets, mean([HausdorffLevelSetsTemporal{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianHausdorff_LevelSets = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianHausdorff_LevelSets = [globalResults.MedianHausdorff_LevelSets, median([HausdorffLevelSetsTemporal{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdHausdorff_LevelSets = std([HausdorffLevelSetsTemporal{:}]);

%% STATISTICS CALCULATION - REFINEMENT PROCESS %%

%% IterOtsu method

globalResults.AveragetotalTimeIterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AveragetotalTimeIterOtsuRefined = [globalResults.AveragetotalTimeIterOtsuRefined, mean([totalTimeIterOtsuTemporalRefined{:,i}])];%mean(totalTimeIterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MediantotalTimeIterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MediantotalTimeIterOtsuRefined = [globalResults.MediantotalTimeIterOtsuRefined, median([totalTimeIterOtsuTemporalRefined{:,i}])];% median(totalTimeIterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdtotalTimeIterOtsuRefined = std([totalTimeIterOtsuTemporalRefined{:}]);%[StdtotalTimeIterOtsuRefined, std(totalTimeIterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];


globalResults.AverageTP_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageTP_IterOtsuRefined = [globalResults.AverageTP_IterOtsuRefined, mean([TP_IterOtsuTemporalRefined{:,i}])];%mean(TP_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianTP_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianTP_IterOtsuRefined = [globalResults.MedianTP_IterOtsuRefined, median([TP_IterOtsuTemporalRefined{:,i}])];%median(TP_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdTP_IterOtsuRefined = std([TP_IterOtsuTemporalRefined{:}]);%[StdTP_IterOtsuRefined, std(TP_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];

globalResults.AverageFP_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageFP_IterOtsuRefined = [globalResults.AverageFP_IterOtsuRefined, mean([FP_IterOtsuTemporalRefined{:,i}])];%mean(FP_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianFP_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianFP_IterOtsuRefined = [globalResults.MedianFP_IterOtsuRefined, median([FP_IterOtsuTemporalRefined{:,i}])];%median(FP_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdFP_IterOtsuRefined = std([FP_IterOtsuTemporalRefined{:}]);%[StdFP_IterOtsuRefined, std(FP_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];

globalResults.AverageFN_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageFN_IterOtsuRefined = [globalResults.AverageFN_IterOtsuRefined, mean([FN_IterOtsuTemporalRefined{:,i}])];%mean(FN_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianFN_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianFN_IterOtsuRefined = [globalResults.MedianFN_IterOtsuRefined, median([FN_IterOtsuTemporalRefined{:,i}])];%median(FN_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdFN_IterOtsuRefined = std([FN_IterOtsuTemporalRefined{:}]);%[StdFN_IterOtsuRefined, std(FN_IterOtsuTemporalRefined((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];

%% DICE COEFFICIENT
globalResults.AverageDice_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageDice_IterOtsuRefined = [globalResults.AverageDice_IterOtsuRefined, mean([DiceCoefficientIterOtsuTemporalRefined{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianDice_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianDice_IterOtsuRefined = [globalResults.MedianDice_IterOtsuRefined, median([DiceCoefficientIterOtsuTemporalRefined{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdDice_IterOtsuRefined = std([DiceCoefficientIterOtsuTemporalRefined{:}]);

%% HAUSDORFF DISTANCE
globalResults.AverageHausdorff_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.AverageHausdorff_IterOtsuRefined = [globalResults.AverageHausdorff_IterOtsuRefined, mean([HausdorffIterOtsuTemporalRefined{:,i}])];%mean(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.MedianHausdorff_IterOtsuRefined = [];
for i=1:NUMBER_OF_IMAGES
    globalResults.MedianHausdorff_IterOtsuRefined = [globalResults.MedianHausdorff_IterOtsuRefined, median([HausdorffIterOtsuTemporalRefined{:,i}])];%median(FN_IterOtsuTemporal((((i-1)*NUMBER_OF_TESTS)+1):(NUMBER_OF_TESTS*i)))];
end;

globalResults.StdHausdorff_IterOtsuRefined = std([HausdorffIterOtsuTemporalRefined{:}]);