%% SCRIPT TO CREATE THE GROUND TRUTH FROM MRI AND CT IMAGES
% - All images should include _ROI.png at the end
% - The GT should be in a mat file. Check that the format is exactly the same
% as other GTs: double with 1's and 0's.

SOURCE_FOLDER = 'images/source';
MRI_image_name = {'sujet01_label_2_63.png', 'sujet02_label_2_63.png', 'sujet03_label_2_63.png'};
CT_image_name_png = {'l1_gt.png', 'l6_gt.png', 'l7_gt.png', 'l8_gt.png', 'lungs1_gt.png', 'lungs2_gt.png'};
CT_image_name_pgm = {'rodilla1_gt.pgm', 'rodilla2_gt.pgm', 'rodilla3_gt.pgm', 'rodilla4_gt.pgm'};

% Convert the pgm files to png
for i =1:size(CT_image_name_pgm,2)
    imageName = CT_image_name_pgm{i};
    imageName = strrep(imageName,'_gt','');
    I = imread(strcat(SOURCE_FOLDER,'\',imageName));
    imwrite(I,strrep(strcat(SOURCE_FOLDER,'\',imageName,'.png'),'.pgm',''))
    I = imread(strcat(SOURCE_FOLDER,'\',CT_image_name_pgm{i}));
    I=255-I;
    imwrite(I,strrep(strcat(SOURCE_FOLDER,'\',CT_image_name_pgm{i},'.png'),'.pgm',''))
    disp('ok')
end;

% Open the png files (MRI and CT) and:
% a) in MRI convert grey to white -> white (foreground) and black (background)
% b) save the .mat for the ground truth
% The GT is saved with exactly the same name as the image in a .mat file.
% Internally, such a mat file contains the variable new_image
for i =1:size(MRI_image_name,2)
    I = imread(strcat(SOURCE_FOLDER,'\',MRI_image_name{i}));
    I(I>0)=255;
    new_image = double(I/255);
    filename = strrep(strcat(SOURCE_FOLDER,'\',MRI_image_name{i},'.mat'),'.png','');
    filename = strrep(filename,'_label','');
    save(filename,'new_image')
    I = imread(strcat(SOURCE_FOLDER,'\',strrep(MRI_image_name{i},'_label','')));
    filename = strcat(SOURCE_FOLDER,'\',strrep(strrep(MRI_image_name{i},'_label',''),'.png',''),'_ROI.png');
    imwrite(I,filename,'png')
    disp('ok')
end;

for i =1:size(CT_image_name_png,2)
    I = imread(strcat(SOURCE_FOLDER,'\',CT_image_name_png{i}));
    I(I>0)=255;
    new_image = double(I/255);
    filename = strrep(strcat(SOURCE_FOLDER,'\',CT_image_name_png{i},'.mat'),'.png','');
    filename = strrep(filename,'_gt','');
    save(filename,'new_image')
    I = imread(strcat(SOURCE_FOLDER,'\',strrep(CT_image_name_png{i},'_gt','')));
    filename = strcat(SOURCE_FOLDER,'\',strrep(strrep(CT_image_name_png{i},'_gt',''),'.png',''),'_ROI.png');
    imwrite(I,filename,'png')
    disp('ok')
end;

for i =1:size(CT_image_name_pgm,2)
    I = imread(strrep(strcat(SOURCE_FOLDER,'\',CT_image_name_pgm{i},'.png'),'.pgm',''));
    I(I>0)=255;
    new_image = double(I/255);
    filename = strrep(strcat(strrep(strcat(SOURCE_FOLDER,'\',CT_image_name_pgm{i},'.png'),'.pgm',''),'.mat'),'.png','');
    filename = strrep(filename,'_gt','');
    save(filename,'new_image')
    I = imread(strcat(strrep(strrep(strcat(SOURCE_FOLDER,'\',CT_image_name_pgm{i},'.png'),'.pgm',''),'_gt','')));
    filename = strcat(strrep(strrep(strrep(strcat(SOURCE_FOLDER,'\',CT_image_name_pgm{i},'.png'),'.pgm',''),'_gt',''),'.png',''),'_ROI.png');
    imwrite(I,filename,'png')
    disp('ok')
end;
disp('ok')

