function roi_img = preprocess_roiLocal(hip_img, image_side)

PERC_MIN_SAT = 0.7; %saturate background
PERC_MAX_SAT = 0.95; %saturate possible parts darker than hippocampus


hip1 = 1-hip_img;
imrow = sort(hip1(:));
bottom = imrow(ceil((PERC_MIN_SAT)*length(imrow)));
top = imrow(ceil((PERC_MAX_SAT)*length(imrow)));
hip1 = (hip1-bottom)/(top-bottom);
hip1(hip1<0) = 0;
hip1(hip1>1) = 1;
if image_side ~= 0
    roi_img=imresize(hip1,[image_side image_side]);
else
    roi_img = hip1;
end;
end