function phi = drlse_edge_mio2(phi_0, timestep, iter, weight,convolution, Img_c)


phi=phi_0;
for k=1:iter
    phi=NeumannBoundCond(phi);
    [phi_x,phi_y]=gradient(phi);
    s=sqrt(phi_x.^2 + phi_y.^2);
    smallNumber=1e-10;  
    Nx=phi_x./(s+smallNumber); % add a small positive number to avoid division by zero
    Ny=phi_y./(s+smallNumber);
    curvature=div(Nx,Ny);
    i =1;
    [Co, h] = contour(phi,[0,0]);
    [x,y] = size(Co);
    while i < y
        %level = Co(1,i);
        dim = Co(2,i);
        for j=i+1:(i+dim)
            i = i+1;
            c_x = round(Co(2,j));
            c_y = round(Co(1,j));
            %phi(c_x, c_y)= phi(c_x, c_y) + timestep*((1-weight)*convolution(c_x,c_y) - (weight*curvature(c_x,c_y))) ;
            phi(c_x, c_y)= phi(c_x, c_y) + timestep*((1-weight)*convolution(c_x,c_y) - (weight*curvature(c_x,c_y))- 0.5*weight*Img_c(c_x,c_y)) ;
        end
        i = i+1;
    end
end


function f = div(nx,ny)
[nxx,junk]=gradient(nx);  
[junk,nyy]=gradient(ny);
f=nxx+nyy;


function g = NeumannBoundCond(f)
% Make a function satisfy Neumann boundary condition
[nrow,ncol] = size(f);
g = f;
g([1 nrow],[1 ncol]) = g([3 nrow-2],[3 ncol-2]);  
g([1 nrow],2:end-1) = g([3 nrow-2],2:end-1);          
g(2:end-1,[1 ncol]) = g(2:end-1,[3 ncol-2]);  