
function [tout18, newmask] = segmentationDSCV(orig_im, out_dir_name,image_name, REFERENCES,best_ref,timestamp, maskpoly)

%% SEGMENTATION USING CHAN AND VESE STARTING FROM THE DEFORMABLE
%% SEGMENTATION USING SCATTER SEARCH (NON-DETERMINISTIC METHOD)

addpath('segmentationMethods\Chan-Vese')

tic

originalSize = size(orig_im);
I = im2uint8(orig_im);
I = imresize(I, [1000 1000]);%[1000 1000] [500 500] [400 400]
I = medfilt2(I, [10 10]); % [20 20] [10 10] [5 5]
I = addborder(I, 15, 175, 'inner');%20 10
% if maskpoly == 0
%     phi2 = chenvese(I,'whole',500,0.1,'chan');%'multiphase' 'chan'
% %     phi = ~phi2;
% else
phi = imresize(maskpoly,[1000 1000]);
phi(phi ~= 0) = 1;
%     se = strel('ball',20,0);
%     phi = imdilate(phi,se);
se = strel('ball',30,0);
maskpoly2 = imdilate(phi,se);
%     BW = edge(phi);
%     phi = -bwdist(BW);
%     phi(maskpoly2 == 1) = - phi(maskpoly2 == 1);
%     specialImages1 =      {'Atrx_133_32','Cd9_30','Cutl2_30','Gfap_95_2307','Mbp_130','Zim1_117'};
%     specialImages1 = {'Cutl2_30','Gfap_95_2307','Mbp_130'};
%     if ismember(image_name,specialImages1)
%         phi2 = chenvese(I,'whole',500,0.1,'chan');%'multiphase' 'chan'
% %         phi2 = ~phi2;
%     else

% test to use 'multiphase'
% maskpoly2_cropped = imcrop(maskpoly2, [10, 10, size(maskpoly2,1)-11, size(maskpoly2,2)-11]);
% maskpoly2_filled = zeros(1000,1000);
% for i=1:size(maskpoly2_cropped,1)
%     for j=1:size(maskpoly2_cropped,2)
%         maskpoly2_filled(i,j)=maskpoly2_cropped(i,j);
%     end;
% end;
% maskpoly3(:,:,1)=maskpoly2;
% maskpoly3(:,:,2)=maskpoly2_filled;
% phi2 = chenvese(I,maskpoly3,500,0.1,'multiphase');%'multiphase' 'chan'

phi2 = chenvese(I,maskpoly2,500,0.1,'chan');%'multiphase' 'chan'
%     end;
% phi = ~phi2;
% % end;
% % refining some details
phi = addborder(phi2, 20, 0, 'inner');% 25 20 10
% phi = imfill(phi,'holes');

newmask = phi;
I = imresize(newmask, originalSize);

newmask= double(I);

hippo_filename = sprintf('%s/%s_Final_DSCV_Config%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp);
imwrite(newmask, hippo_filename,'png');


close all

outputImage = zeros(size(newmask));

CC = bwconncomp(newmask,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
[ordered,idx] = sort(numPixels,'descend');
ordered(ordered < 5000) = 0;
% con_component=2; %minimum number of con_components
for c=1:size(idx,2)%con_component
    if (ordered(c)) ~= 0
        outputImage(CC.PixelIdxList{idx(c)}) = 1;
    end;
end

% CC = bwconncomp(newmask,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
% numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
% [ordered,idx] = sort(numPixels,'descend');
% con_component=2; %minimum number of con_components
% for c=1:con_component
%     outputImage(CC.PixelIdxList{idx(c)}) = 1;
% end

newmask = outputImage;

tout18 = toc;

%%   SAVE IMAGES
save(strcat(out_dir_name,'/',image_name,'_DSCV.mat'),'newmask');

hippo_filename = sprintf('%s/%s_orig_im_newmask_DSCV_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

hippo_filename = sprintf('%s/%s_newmask_DSCV_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(newmask, hippo_filename,'png');

