
function [tout21, newmask] = segmentationDSGAC(orig_im, out_dir_name,image_name, REFERENCES,best_ref,timestamp, newmaskDS)

%% SEGMENTATION USING GEODESIC ACTIVE CONTOURS STARTING FROM THE DEFORMABLE
%% SEGMENTATION USING SCATTER SEARCH (NON-DETERMINISTIC METHOD)

addpath('segmentationMethods\GeodesicActiveContours')

tic

originalSize = size(orig_im);
I = im2uint8(orig_im);
I = imresize(I, [1000 1000]);

I = medfilt2(I, [10 10]); % [20 20]

g = ac_gradient_map(I);

g2 = addborder(g, 20, 0.8, 'inner');


phi = imresize(newmaskDS,[1000 1000]);
phi(phi ~= 0) = 1;
se = strel('ball',20,0);
phi = imdilate(phi,se);
se = strel('ball',30,0);
maskpoly2 = imdilate(phi,se);

BW = edge(phi);
phi = -bwdist(BW);
phi(maskpoly2 == 1) = - phi(maskpoly2 == 1);


countour_weight = 3; %4
expansion_weight = -1;%0.5; %-0.5
delta_t = 5; %5 4
n_iters = 1000; show_result = 1;%0
phi = ac_GAC_model(g2, phi, countour_weight, expansion_weight, ...
    delta_t, n_iters, show_result);

newmask = phi;
I = imresize(newmask, originalSize);
I = im2uint8(I);
I(I<255) = 0;
I(I==255) = 1;
% newmask = imfill(I,'holes');
newmask= double(I);
hippo_filename = sprintf('%s/%s_Final_DSGAC_Config%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp);
saveas(gcf,hippo_filename,'png')
close all

outputImage = zeros(size(newmask));

CC = bwconncomp(newmask,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
[ordered,idx] = sort(numPixels,'descend');
ordered(ordered < 5000) = 0;
% con_component=2; %minimum number of con_components
for c=1:size(idx,2)%con_component
    if (ordered(c)) ~= 0
        outputImage(CC.PixelIdxList{idx(c)}) = 1;
    end;
end

% CC = bwconncomp(newmask,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
% numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
% [ordered,idx] = sort(numPixels,'descend');
% con_component=2; %minimum number of con_components
% for c=1:con_component
%     outputImage(CC.PixelIdxList{idx(c)}) = 1;
% end

newmask = outputImage;

tout21 = toc;

%%   SAVE IMAGES
save(strcat(out_dir_name,'/',image_name,'_DSGAC.mat'),'newmask');

hippo_filename = sprintf('%s/%s_orig_im_newmask_DSGAC_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

hippo_filename = sprintf('%s/%s_newmask_DSGAC_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI
imwrite(newmask, hippo_filename,'png');

