function [tout13, newmask] = ...
    segmentationFCM(orig_im, out_dir_name,image_name, REFERENCES,best_ref,timestamp)

%% FUZZY C-MEANS: DETERMINISTIC METHOD

refinement = 0;
% Fill holes & remove smallest connected components. It's important to
% notice that this is an improvement that it's not part of the K-Means
% algorithm, so maybe it's better not to use it.

tic

originalSize= size(orig_im);
orig_im2 = imresize(orig_im,[1000 1000]);

[center,U,obj_fcn] = fcm(orig_im2,2);
tmp_roi = orig_im;
averageValue = mean(center(1,:));
tmp_roi(tmp_roi < averageValue) = 0;
tmp_roi(tmp_roi > 0) = 255;
tmp_roi(tmp_roi == 255) = 5;
tmp_roi(tmp_roi == 0) = 255;
tmp_roi(tmp_roi == 5) = 0;

outputImage = imresize(tmp_roi, originalSize);
% outputImage = mask;
outputImage(outputImage>0)=255;
outputImage(outputImage==255)=1;

tmp_roi = outputImage;

if refinement
    outputImage = tmp_roi; %imfill(tmp_roi,'holes');
    outputImage2 = zeros(size(tmp_roi));
    
    %     CC = bwconncomp(outputImage,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
    %     numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
    %     [ordered,idx] = sort(numPixels,'descend');
    %     con_component=2; %minimum number of con_components
    %     for c=1:con_component
    %         outputImage(CC.PixelIdxList{idx(c)}) = 1;
    %     end
    
    CC = bwconncomp(outputImage,8); % A scalar connectivity specifier must be 1, 4, 6, 8, 18, or 26.
    numPixels = cellfun(@numel,CC.PixelIdxList);% number of pixels of each connected component
    [ordered,idx] = sort(numPixels,'descend');
    ordered(ordered < 5000) = 0;
    % con_component=2; %minimum number of con_components
    for c=1:size(idx,2)%con_component
        if (ordered(c)) ~= 0
            outputImage2(CC.PixelIdxList{idx(c)}) = 1;
        end;
    end
    
    newmask = outputImage2;
else
    newmask = tmp_roi;
end;

tout13 = toc; % time: segmentation Fuzzy C-Means

save(strcat(out_dir_name,'/',image_name,'_FCM.mat'),'newmask');

hippo_filename = sprintf('%s/%s_orig_im_newmask_FCM_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

save(strcat(out_dir_name,'/',image_name,'_FCM.mat'),'newmask');

hippo_filename = sprintf('%s/%s_newmask_FCM_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(newmask, hippo_filename,'png');

