
function [tout21, newmask] = segmentationNewHybrid(orig_im, out_dir_name,image_name, ...
    REFERENCES,best_ref,timestamp, gammaVFC,lambda_in,lambda_out,weightCV,weightPrior,weightVFC, ImageModality)

%% SEGMENTATION USING OUR NEW APPROACH STARTING FROM THE DEFORMABLE
%% SEGMENTATION USING SCATTER SEARCH (NON-DETERMINISTIC METHOD)
addpath('segmentationMethods\newHybridMethod\')

tic

% Usage: command image_file prior_file [-param_name param_value]
% Available parameters: -lambda_in -lambda_out -Na -Ns -kernel_curve -std_curve -out_dir
% -weightCV -weightPrior -weightVFC -verbose -phi_init_type -gammaVFC -cache_dir -compute_vfc_only

% Manual example of use:
% segmentationMethods\newHybridMethod\Ofeli_cmd.exe images\source\simpleTest1.png images\source\simpleTest1_prior.png -out_dir images\hippocampi\outTestOfeli
if strcmp(ImageModality, 'ISH')
    command = ['segmentationMethods\newHybridMethod\Ofeli_cmd.exe ', ...
        strrep(strcat(out_dir_name,filesep,image_name,'_orig_im',num2str(REFERENCES(best_ref)),'_',timestamp,'.png'), '/', '\'),' ', ...
        strrep(strcat(out_dir_name,filesep,image_name,'_newmask_DS_',num2str(REFERENCES(best_ref)),'_',timestamp,'.png'), '/', '\'), ' ', ...
        ' -out_dir ', strrep(strcat(out_dir_name,filesep,'newHybridMethodResults'), '/', '\'), ' ', ...
        ' -gammaVFC ', num2str(gammaVFC), ...
        ' -lambda_in ', num2str(lambda_in), ...
        ' -lambda_out ', num2str(lambda_out), ...
        ' -weightCV ', num2str(weightCV), ...
        ' -weightPrior ', num2str(weightPrior), ...
        ' -weightVFC ', num2str(weightVFC)];
else
    command = ['segmentationMethods\newHybridMethod\Ofeli_cmd.exe ', ...
        strrep(strcat(out_dir_name,filesep,image_name,'_orig_im_',timestamp,'.png'), '/', '\'),' ', ...
        strrep(strcat(out_dir_name,filesep,image_name,'_newmask_DS_',timestamp,'.png'), '/', '\'), ' ', ...
        ' -out_dir ', strrep(strcat(out_dir_name,filesep,'newHybridMethodResults'), '/', '\'), ' ', ...
        ' -gammaVFC ', num2str(gammaVFC), ...
        ' -lambda_in ', num2str(lambda_in), ...
        ' -lambda_out ', num2str(lambda_out), ...
        ' -weightCV ', num2str(weightCV), ...
        ' -weightPrior ', num2str(weightPrior), ...
        ' -weightVFC ', num2str(weightVFC)];
end;
system(command); %execute external command
%     ' -cache_dir ',strrep(strcat(out_dir_name,filesep,'newHybridMethodResults\cache'), '/', '\'), ...

newmask= im2double(imread(strrep(strcat(out_dir_name,filesep,'newHybridMethodResults/out_last.png'), '/', '\')));

tout21 = toc;

%%   SAVE IMAGES
save(strcat(out_dir_name,'/',image_name,'_newHybrid.mat'),'newmask');

if best_ref ~= -1
    hippo_filename = sprintf('%s/%s_orig_im_newmask_newHybrid_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI
else
    hippo_filename = sprintf('%s/%s_orig_im_newmask_newHybrid_%s.png',out_dir_name,image_name, timestamp); %save extracted ROI
end;

imwrite(im2double(orig_im).*newmask, hippo_filename,'png');
if best_ref ~= -1
    hippo_filename = sprintf('%s/%s_newmask_newHybrid_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI
else
    hippo_filename = sprintf('%s/%s_newmask_newHybrid_%s.png',out_dir_name,image_name, timestamp); %save extracted ROI
end;
imwrite(newmask, hippo_filename,'png');

