function [tout11, newmask] = ...
    segmentationSimpleLevelSet(roi_points, roi_pointsdg, orig_im, ...
    SaveSegmentationEvolution, out_dir_name,image_name, REFERENCES,best_ref,timestamp)


% this code uses a simple Level Set implementation, that takes into account
% only grey level intensities (no shape prior knowledge, no texture, no colour,...)
% it's like a Chan-Vese approach but taking into account only the seed
% pixels inside the hippocampus (mean and std of the grey levels).
% There are no shape restrictions, and the external part of the hippocampus
% is not taken into account.


tic
% cartesian coordinates of the final models
modelca = roi_points;
modeldg = roi_pointsdg;

im= orig_im;

[dim_x dim_y] = size(im);
point = [modelca; modeldg];

%determing mid points
t_dim = size(modelca,1);
%         figure,plot(modelca(:,1),modelca(:,2),'r*')
for i=1:1:t_dim-1
    mid_point_tmp(i,1) = (modelca(i,1) + modelca(i+1, 1))/2.0;
    mid_point_tmp(i,2) = (modelca(i,2) + modelca(i+1, 2))/2.0;
end
t_dim = size(mid_point_tmp,1);
%         figure,plot(modelca(:,1),modelca(:,2),'r*')
for i=1:1:t_dim-1
    mid_point(i,1) = (mid_point_tmp(i,1) + mid_point_tmp(i+1, 1))/2.0;
    mid_point(i,2) = (mid_point_tmp(i,2) + mid_point_tmp(i+1, 2))/2.0;
end
%         hold on,
%         plot(mid_point(:,1),mid_point(:,2),'b*')

%determing mid points
t_dim1 = size(modeldg,1);
%         figure,plot(modeldg(:,1),modeldg(:,2),'bv')
mid_point2 = [];
for i=1:1:t_dim1-1
    mid_point2_tmp(i,1) = (modeldg(i,1) + modeldg(i+1, 1))/2.0;
    mid_point2_tmp(i,2) = (modeldg(i,2) + modeldg(i+1, 2))/2.0;
end
t_dim1 = size(mid_point2_tmp,1);
%         figure,plot(modeldg(:,1),modeldg(:,2),'bv')
for i=1:1:t_dim1-1
    mid_point2(i,1) = (mid_point2_tmp(i,1) + mid_point2_tmp(i+1, 1))/2.0;
    mid_point2(i,2) = (mid_point2_tmp(i,2) + mid_point2_tmp(i+1, 2))/2.0;
end
%         hold on,
%         plot(mid_point2(:,1),mid_point2(:,2),'go')
mid_point = [mid_point;mid_point2];

t_dim = t_dim+t_dim1;

t_dim_2 = size(mid_point,1);
point((t_dim+1):(t_dim+t_dim_2), :) = mid_point(:,:);

%variable to calculate mean and std in the surrounding of each
%initial point
box = 5;
meanValue = 0.0;
meanValue = double(meanValue);
dev = 0.0;
for i=1:size(point,1)
    parte = im(floor(point(i,2))-box:floor(point(i,2))+box,floor(point(i,1))-box:floor(point(i,1))+box);
    %         mean(mean(parte));
    meanValue = meanValue + mean(mean(parte));
end

meanValue = double(meanValue) / size(point,1);
voxel =0;
for i=1:size(point,1)
    parte = im(floor(point(i,2))-box:floor(point(i,2))+box,floor(point(i,1))-box:floor(point(i,1))+box);
    for x=1:size(parte,1)
        for y=1:size(parte,2)
            dev = dev + (meanValue - double(parte(x,y)))^2;
            voxel = voxel+1;
        end
    end
end

dev = sqrt(double(dev)/ double(voxel));

thresholdValue =  dev;

%variable to crop the image, computationally more efficent
%the cropping values are detemined looking to the initial points
%sometimes if the initial points are wrong can happen that the crop image
%excludes parts or the ippocampus
bordo = 100*box; %30 100
clear crop_min_x crop_max_x crop_min_y crop_max_y
crop_min_x = min(point(:,2)) - bordo;
crop_max_x = max(point(:,2)) + bordo;
crop_min_y = min(point(:,1)) - bordo;
crop_max_y = max(point(:,1)) + bordo;
if (crop_min_x < 1)
    crop_min_x = 1;
end
if (crop_max_x > dim_x)
    crop_max_x = dim_x;
end
if (crop_min_y < 1)
    crop_min_y = 1;
end
if (crop_max_y > dim_y)
    crop_max_y = dim_y;
end
point(:,1) = point(:,1) - (crop_min_y);
point(:,2) = point(:,2) - (crop_min_x);

%resize of the image
b = im(crop_min_x:crop_max_x, crop_min_y:crop_max_y);
scale = 0.3;
b = imresize(b, scale);

%resize of the initial points
for i=1:size(point,1)
    point(i,1) = ceil(point(i,1) * scale);
    point(i,2) = ceil(point(i,2) * scale);
end

Img=b;
Img=double(Img(:,:,1));

% % parameter setting
%     timestep=1;  % time step
mu=100;% 2000(full size) 0.2/timestep;  % coefficient of the distance regularization term R(phi)
iter_inner=1;
iter_outer=250; %200(fullsize)

%     epsilon=1.5; %1.5 papramater that specifies the width of the DiracDelta function

%     %is possible to smooth the image
%     %for the moment I don't do it because is already resized
%     Img_smooth=Img;

sigma=2;    % scale parameter in Gaussian kernel
G=fspecial('gaussian',100,sigma); % Caussian kernel
Img_smooth=conv2(Img,G,'same');  % smooth image by Gaussiin convolution



% initialize LSF as binary step function
c0=2;
initialLSF = c0*ones(size(Img));

for i =1: size(point,1)
    if ((point(i,2)-box) <= 0)
        newPoint2 = 1;
    else
        newPoint2 = point(i,2)-box;
    end;
    if ((point(i,1)-box) <= 0)
        newPoint1 = 1;
    else
        newPoint1 = point(i,1)-box;
    end;
    %         disp('antes')
    %         point(i,2)-box:point(i,2)+box,point(i,1)-box:point(i,1)+box
    %         disp('despues')
    %         newPoint2:point(i,2)+box,newPoint1:point(i,1)+box
    initialLSF(newPoint2:point(i,2)+box,newPoint1:point(i,1)+box)=-c0;
end

% phi is initialized as the initial level set function. being this the
% points located previously by the model
phi=initialLSF;

%         % % visualization
%         figure(1);
%         mesh(-phi);   % for a better view, the LSF is displayed upside down
%         hold on;  contour(phi, [0,0], 'r','LineWidth',2);
%         title('Initial level set function');
%
%
%         figure(2);
%         %imagesc(Img_smooth,[0, 255]);
%         imshow(Img_smooth);axis off; axis equal; colormap(gray); hold on;  contour(phi, [0,0], 'r');
%         title('Initial zero level contour');


savingNumberImage = 1;
% start level set evolution
divisione = thresholdValue^2 + (Img_smooth - meanValue).^2;
convolution = ((2*(Img_smooth - meanValue).^2)./(divisione) - 1);
for n=1:iter_outer
    phi = drlse_edge_mio(phi, mu, iter_inner, 0.1, convolution);
    
    if SaveSegmentationEvolution==1
        % visualization
        if (mod(n,2)==0)
            %                     figure(2);
            %                     %imshow(phi);
            %                     %imagesc(Img_smooth,[0, 255]);
            %                     imshow(Img_smooth);axis off; axis equal; colormap(gray); hold on;  contour(phi, [0,0], 'r');
            phi2=1-phi;
            RGBphi = repmat(uint8(255.*phi2),[1 1 3]);
            RGBphi(:,:,3) = 0;
            RGBphi(:,:,2) = 0;
            
            RGBImg_smooth = repmat(uint8(255.*Img_smooth),[1 1 3]);
            index_find=find(RGBphi(:,:,1)==255 & RGBphi(:,:,2)==0 & RGBphi(:,:,3)==0);
            RGBImg_smooth(index_find) = 255;
            RGBImg_smooth(index_find+size(RGBImg_smooth,1)*size(RGBImg_smooth,2)) = 0;
            RGBImg_smooth(index_find+2*size(RGBImg_smooth,1)*size(RGBImg_smooth,2)) = 0;
            nameFileEvolutione = sprintf('%s/%s_LevelSet_Evolution%d.png',out_dir_name,image_name, savingNumberImage);
            imwrite(RGBImg_smooth, nameFileEvolutione,'png');
            savingNumberImage = savingNumberImage + 1 ;
        end
        %
    end;
end

close all;

finalLSF=phi;

%going back to the original size
% final_image = zeros(size(im,1), size(im,2));
finalLSF = 1-finalLSF;
finalLSF(finalLSF <0) = 0;
finalLSF(finalLSF >0) = 1;
finalLSF = imresize(finalLSF, [crop_max_x-crop_min_x+1 crop_max_y-crop_min_y+1]);
final = zeros(dim_x, dim_y);
%     [round(crop_min_x), round(crop_max_x),round(crop_min_y), round(crop_max_y)]
%     [abs(ceil(crop_min_x)-ceil(crop_max_x)-1),abs(ceil(crop_min_y)-ceil(crop_max_y)-1)]
%     [abs(crop_min_x-crop_max_x-1),abs(crop_min_y-crop_max_y-1)]
%     size(final)
%     size(finalLSF)
try
    final(ceil(crop_min_x):ceil(crop_max_x), ceil(crop_min_y):ceil(crop_max_y)) = finalLSF(:,:);
catch
    if size(ceil(crop_min_x):ceil(crop_max_x),2)~=size(finalLSF,1)
        valueToAdd1 = size(finalLSF,1)-size(ceil(crop_min_x):ceil(crop_max_x),2);
        %valueToAdd2 = size(finalLSF,2)-size(ceil(crop_min_y):ceil(crop_max_y),2);
        %final(ceil(crop_min_x)-valueToAdd1:ceil(crop_max_x), ceil(crop_min_y):ceil(crop_max_y)) = finalLSF(:,:);
    else
        valueToAdd1 = 0;
    end;
    if size(ceil(crop_min_y):ceil(crop_max_y),2)~=size(finalLSF,2)
        valueToAdd2 = size(finalLSF,2)-size(ceil(crop_min_y):ceil(crop_max_y),2);
    else
        valueToAdd2 = 0;
    end;
    final(ceil(crop_min_x)-valueToAdd1:ceil(crop_max_x), ceil(crop_min_y)-valueToAdd2:ceil(crop_max_y)) = finalLSF(:,:);
end

% % HACER EL IMFILL
final(final > 0.5) = 1;
final(final <= 0.5)=0;
newmask = imfill(final,'holes');
%     newmask(newmask > 0.5) = 1;
%     newmask(newmask <= 0.5)=0;

tout11 = toc; % time: segmentation LevelSetsMethod


save(strcat(out_dir_name,'/',image_name,'_LevelSets.mat'),'newmask');

hippo_filename = sprintf('%s/%s_orig_im_newmask_LevelSets_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(orig_im.*newmask, hippo_filename,'png');

save(strcat(out_dir_name,'/',image_name,'_LevelSets.mat'),'newmask');

hippo_filename = sprintf('%s/%s_newmask_LevelSets_%d_%s.png',out_dir_name,image_name, REFERENCES(best_ref),timestamp); %save extracted ROI

imwrite(newmask, hippo_filename,'png');

