function [Bartlett_pValue homoscedasticity] ...
    = homoscedasticityCheck(M,significanceLevel, fileID)

fprintf(fileID,'HOMOSCEDASTICITY CHECK: Bartlett test\n');

% vartestn(X) performs Bartlett's test for equal variances for the columns
% of the matrix X. This is a test of the null hypothesis that the columns
% of X come from normal distributions with the same variance, against the
% alternative that they come from normal distributions with different variances.
[Bartlett_pValue,STATS] = vartestn(M);
close all;
if Bartlett_pValue < significanceLevel
    homoscedasticity = 0;
    label = sprintf('The data do NOT accomplish the homoscedasticity assumption');
    disp(label);
else
    homoscedasticity = 1;
    label = sprintf('The data do accomplish the homoscedasticity assumption');
    disp(label);
end;

fprintf(fileID,'p-value: %d\n',Bartlett_pValue);
fprintf(fileID,strcat(label,'\n'));

fprintf(fileID,'\n');